/*
Название: SelectAndAlign.jsx
Приложение для использования: Adobe InDesign CS3, CS4, CS5
Версия: 1.0
Язык реализации (Среда): JavaScript (ExtendScript Toolkit 2)
Операционные системы (Платформы): PC, Macintosh (Windows, Mac OS)
Условия распространения: Бесплатно; На Ваш риск
Назначение: Выравнивание выделенных объектов
Функциональные ограничения: Не работает с выделенными направляющими
Примечание: Создается дополнительный временный файл SelectAndAlign.ini для хранения данных
Техническая поддержка: Sergey-Anosov@yandex.ru
===================================================
Name: SelectAndAlign.jsx
Application to use with: Adobe InDesign CS3, CS4, CS5
Version: 1.0
Program language (Environment): JavaScript (ExtendScript Toolkit 2)
Operating systems (Platforms): PC, Macintosh (Windows, Mac OS)
Distribution conditions: Freeware; At your own risk
Functions: Alignment of selected  objects
Functional limitations: Can not process selection containing guides
Note: Creates additional temporary file SelectAndAlign.ini for data
Technical support: Sergey-Anosov@yandex.ru
*/
// описание глобальных переменных
var the_title = "Select and Align";
var the_script_name = "SelectAndAlign";
var the_version = "1.0";
var AD; // активный док-т
var AL; // активный слой
var AP; // активная страница
var AS;// активный разворот
 // выделение в акт. док-те
var the_sel = new Array();
// массив ID первого выделения
var SEL_1_ID = new Array();
// референсные объекты
var REF_OBJ = new Array();
var REF_OBJ_BOUNDS;
var N_REF_OBJ = 0;
// перемещаемые объекты
var MOV_OBJ = new Array();
var MOV_OBJ_BOUNDS;
var N_MOV_OBJ = 0;
// снимать выделение (после 1 диалога)
var DESEL = false;
var SEL_AFTER;
var N_sel = 0; // кол-во объектов в выделении
var N_sel_1 = 0; // кол-во объектов в 1 выделении
var N_doc = 0; //  кол-во док-тов в InDesign
var dlg; // основной диалог
var AD_old_ruler_origin ;// старые настройки для сохранения
var BL = "\n";// первод строки
//
var SCRIPT_FILE = new File();
var INI_FILE = new File();
var INI_EXISTS = true;
var INI_ERR = false;
var AT = AB = AL = AR = ACH = ACV = AV = AH = false;
var LIKE_GROUP = true;
var SHIFT_X = 0., SHIFT_Y = 0.;
// первое выделение перемещается ?
var FIRST_MOVED = 1;
// файловая система
var WFS = false;
// старые настройки прорисовки
var old_script_pref;
// максимальное число циклов
var MAX_LOOP = 50000;
// перемещаем копии
var MOVE_COPY = false;
// перемещать заблокированные
var MOV_LOCK = false;
// была ошибка при перемещении
var MOVE_ERR = false;
// массив копий объектов
var COPY_ARR = new Array();
//
// вызов главной подпрограммы
main();
// окончание выполнения скрипта :)))
//
// блок описания подпрограмм
// основная подпрограмма
function main () 
{
	AFTER_RUN();
	return;
};//end main()
//
// продпрограмма выполнения скрипта (в диалоге был ОК)
function ALIGN() 
{
	if( !MOVE_COPY )
	{
		// нет ли заблокированных объектов среди перемещаемых
		for( var i=0; i < MOV_OBJ.length; i++)
		{
			if( (MOV_OBJ[i].locked ) || (IN_LOCKED(MOV_OBJ[i])) ) { MOV_LOCK = true; break }
		};// for
		if( MOV_LOCK )
		{
			if( !confirm("Some of the objects to be moved are locked!\n"+
						      "Unlock and continue?") ) exit();
		};// if
	};// if
	// сохраняем старые значения
	SAVE_OLD_DOC_SETTINGS();
	if( !AL && !AR && !AT && !AB && !ACH && !ACV )
	{
		the_exit("No direction were selected!");
	};// if
	// ставим отсчет как для разворота
	AD.viewPreferences.rulerOrigin = RulerOrigin.spreadOrigin;
	// габариты рефенсных объектов
	var REF_L, REF_T, REF_R, REF_B, REF_CH, REF_CV;
	var REF_BOUNDS = new Array();
	REF_BOUNDS = GET_ARR_BOUNDS( REF_OBJ, REF_OBJ_BOUNDS);
	REF_L = REF_BOUNDS[0];
	REF_T = REF_BOUNDS[1];
	REF_R = REF_BOUNDS[2];
	REF_B = REF_BOUNDS[3];
	REF_CH = REF_L + ( REF_R - REF_L )/2.;
	REF_CV = REF_T + ( REF_B - REF_T )/2.;
	// если перемещаем как группа
	if( LIKE_GROUP )
	{
		// определяем габарит перемещаемых объектов
		var MOV_L, MOV_T, MOV_R, MOV_B, MOV_CH, MOV_CV;
		var MOV_BOUNDS = new Array();
		MOV_BOUNDS = GET_ARR_BOUNDS( MOV_OBJ, MOV_OBJ_BOUNDS);
		MOV_L = MOV_BOUNDS[0];
		MOV_T = MOV_BOUNDS[1];
		MOV_R = MOV_BOUNDS[2];
		MOV_B = MOV_BOUNDS[3];
		MOV_CH = MOV_L + ( MOV_R - MOV_L )/2.;
		MOV_CV = MOV_T + ( MOV_B - MOV_T )/2.;
		var DX = 0., DY = 0.;
		if( AL ) { DX = REF_L - MOV_L };
		if( ACH ) { DX = REF_CH - MOV_CH };
		if( AR ) { DX = REF_R - MOV_R };
		if( AT ) { DY = REF_T - MOV_T };
		if( ACV ) { DY = REF_CV - MOV_CV };
		if( AB ) { DY = REF_B - MOV_B };
		for( var i=0; i < MOV_OBJ.length; i++) 
		{
			try 
			{ 
				if( !MOVE_COPY )
				{
					if( IN_LOCKED( MOV_OBJ[i] ) ) UNLOCK_PARENT( MOV_OBJ[i] );
					if( MOV_OBJ[i].locked ) MOV_OBJ[i].locked = false;
					var MOV_OBJ_i = MOV_OBJ[i];
				}
				else
				{
					var MOV_OBJ_i = MOV_OBJ[i].duplicate();
				};// if-else
				MOV_OBJ_i.move(undefined, [DX+SHIFT_X, DY+SHIFT_Y]) ;
				if( MOVE_COPY ) COPY_ARR.push( MOV_OBJ_i );
			} 
			catch ( error ) 
			{
				MOVE_ERR = true;
				if( MOVE_COPY ) try{ MOV_OBJ_i.remove() } catch( error ) {};
			};
		};// for
	}
	// если перемещаем по отдельности
	else
	{
		// определяем габариты перемещаемых объектов
		var MOV_L = new Array();
		var MOV_T = new Array();
		var MOV_R = new Array();
		var MOV_B = new Array();
		var MOV_CH = new Array();
		var MOV_CV = new Array();
		var MOV_BOUNDS = new Array();
		var DX = new Array(); 
		var DY = new Array();
		for( var i=0; i < MOV_OBJ.length; i++)
		{
			DX[i] = 0.; DY[i] = 0.;
			var the_obj = new Array();
			the_obj[0] = MOV_OBJ[i];
			MOV_BOUNDS = GET_ARR_BOUNDS( the_obj, MOV_OBJ_BOUNDS);
			MOV_L[i] = MOV_BOUNDS[0];
			MOV_T[i] = MOV_BOUNDS[1];
			MOV_R[i] = MOV_BOUNDS[2];
			MOV_B[i] = MOV_BOUNDS[3];
			MOV_CH[i] = MOV_L[i] + ( MOV_R[i] - MOV_L[i] )/2.;
			MOV_CV [i]= MOV_T[i] + ( MOV_B[i] - MOV_T[i] )/2.;
		};// for
		//
		for( var i=0; i < MOV_OBJ.length; i++)
		{
			if( AL ) { DX[i] = REF_L - MOV_L[i] };
			if( ACH ) { DX[i] = REF_CH - MOV_CH[i] };
			if( AR ) { DX[i] = REF_R - MOV_R[i] };
			if( AT ) { DY[i] = REF_T - MOV_T[i] };
			if( ACV ) { DY[i] = REF_CV - MOV_CV[i] };
			if( AB ) { DY[i] = REF_B - MOV_B[i] };
			try 
			{ 
				if( !MOVE_COPY )
				{
					if( IN_LOCKED( MOV_OBJ[i] ) ) UNLOCK_PARENT( MOV_OBJ[i] );
					if( MOV_OBJ[i].locked ) MOV_OBJ[i].locked = false;
					var MOV_OBJ_i = MOV_OBJ[i];
				}
				else
				{
					var MOV_OBJ_i = MOV_OBJ[i].duplicate();
				}
				MOV_OBJ_i.move(undefined, [DX[i]+SHIFT_X, DY[i]+SHIFT_Y]) ;
				if( MOVE_COPY ) COPY_ARR.push( MOV_OBJ_i );
			} 
			catch ( error ) 
			{
				MOVE_ERR = true;
				if( MOVE_COPY ) try{ MOV_OBJ_i.remove() } catch( error ) {};
			};
		};// for
	};// if-else
	//
	DESELECT_ALL();
	if( SEL_AFTER == "All involved objects" ) { SEL_OBJ(MOV_OBJ);  SEL_OBJ(REF_OBJ) };
	if( SEL_AFTER == "Moved objects" ) { SEL_OBJ(MOV_OBJ) };
	if( SEL_AFTER == "Reference objects" ) { SEL_OBJ(REF_OBJ) };
	if( (SEL_AFTER == "Copy") ||  (SEL_AFTER == "Copies") ) { SEL_OBJ(COPY_ARR) };
	if( SEL_AFTER == "Deselect all" ) { };
	if( MOVE_ERR && !MOVE_COPY) alert("Can not move some objects!");
	if( MOVE_ERR && MOVE_COPY) alert("Can not create and move some copies!");
};// end ALIGN
//
// подрограмма определения входит ли объект в массив
function OBJ_IN_ARR( obj, arr )
{
	try
	{
		var obj_id = obj.id;
	} 
	catch (error)
	{
		the_exit("Can not perform the operation!");
	}
	for( var i = 0; i < arr.length; i++)
	{
		try
		{
			if( obj_id == arr[i].id ) return true;
		} catch ( error ) {};
	};// for 
	return false;
};// end OBJ_IN_ARR
//
// подпрограмма получения габаритов массива объектов
function GET_ARR_BOUNDS( arr , b)
{
	var L, T, R, B;
	var L_i, T_i, R_i, B_i;
	var obj_b = new Array();
	for( var i = 0; i < arr.length; i++)
	{
		// получаем границы объекта
		obj_b = OBJ_BOUNDS( arr[i] );
		// геометрические границы
		if( b == "Geometric" ) { L_i = obj_b[0]; T_i = obj_b[1]; R_i = obj_b[2]; B_i = obj_b[3] }
		// видимые границы
		else    { L_i = obj_b[4]; T_i = obj_b[5]; R_i = obj_b[6]; B_i = obj_b[7] };
		// начальное присвоение для сравнения
		if( i == 0)
		{
			L = L_i; T = T_i; R = R_i; B = B_i;
		};// if
		// собственно сравниваем
		if( L_i < L) L = L_i; if( T_i < T ) T = T_i; if( R_i > R) R = R_i; if( B_i > B) B = B_i; 
	};// for
	return [L, T, R, B];
};// end GET_ARR_BOUNDS
//
// подпрограмма проверки выделения
function CHECK_SELECTION() 
{
	// есть ли открытые документы
	N_doc = app.documents.length;
	if (N_doc < 1 ) 
	{
		alert( "There are no open documents!");
		return false;
	};// if
	AD = app.activeDocument;
	AL = AD.activeLayer;
	SEL_LAYER = AL;
	AP = app.activeWindow.activePage
	AS = app.activeWindow.activeSpread;
	the_sel = AD.selection;
	N_sel = the_sel.length;
	if( GUIDES_IN_SELECTION() ) 
	{
		 alert("There are some selected guides!"+BL+"Can not process that!");
		 return false;
	};// if
	if( N_sel == 0 )
	{
		alert("There are no selected objects!");
		 return false;
	};// if
	//
	var BAD_OBJ = false;
	for( var i=0; i < N_sel; i++)
	{
		if ( IN_TEXT( the_sel[i] ) ) {BAD_OBJ = true; break};
		var obj_name = the_sel[i].constructor.name;
		if( (obj_name != "Rectangle") && (obj_name != "Oval") &&
			 (obj_name != "Polygon") && (obj_name != "TextFrame") &&
			 (obj_name != "Group") && (obj_name != "Button") &&
			 (obj_name != "GraphicLine") && (obj_name != "PDF") && 
			 (obj_name != "Image") && (obj_name != "EPS") ) {BAD_OBJ = true; break};
	};// for i
	if( BAD_OBJ )
	{
		alert("Can not process the selection!");
		return false;
	};// if
return true;
};// end CHECK_SELECTION
//
// подпрограмама поиска направляющих в выделении
function GUIDES_IN_SELECTION() 
{
	if( N_sel > 0 ) 
	{
		if( the_sel[0].constructor.name == "Guide" ) return true;
	};
	return false;
};// end GUIDES_IN_SELECTION
//
// подпрограмма определения внедрен ли объект в текстовый фрейм
function IN_TEXT( the_obj_in )
{
	var the_obj = the_obj_in;
	while ( p_name != "Document" )
	{
		try
		{
			var p = the_obj.parent;
			var p_name = p.constructor.name;
			if( p_name == "Character" ) return true;
			the_obj = p;
		} catch ( error ){};
	}
	return false;
};// IN_TEXT( the_obj )
//
// подпрограмма сохранения старых настроек док-та
function SAVE_OLD_DOC_SETTINGS() 
{
	// сохраняем старые настройки отсчета
	AD_old_ruler_origin = AD.viewPreferences.rulerOrigin;
return; 
}//end SAVE_OLD_DOC_SETTINGS
//
// подпрограмма сразу после запуска скрипта
function AFTER_RUN()
{
	// получаем ссылку на файл скрипта
	SCRIPT_FILE = File(app.activeScript);
	// получаем адрес папки со скриптом
	SCRIPT_FOLDER = SCRIPT_FILE.path;
	// получаем ссылку на файл данных
	INI_FILE = File( SCRIPT_FOLDER + "/"+ the_script_name +".ini" );
	// существует ли он
	INI_EXISTS = INI_FILE.exists;
	// если не существует, считаем что это первый вызов скрипта
	if( !INI_EXISTS )
	{
		// если в порядке выделение
		if( CHECK_SELECTION() )
		{
			// если ОК в 1 диалоге
			if( DIALOG_1() )
			{
				if( DESEL ) DESELECT_ALL();
				INI_WRITE();
			}
			else
			// если Cancel в 1 диалоге
			{
				INI_DEL();
			};
		}
		else
		// если НЕ в порядке выделение
		{
			INI_DEL();
		};
	}
	else
	// если существует, считаем что это второй вызов скрипта
	{
		// если в порядке выделение
		if( CHECK_SELECTION() )
		{
			INI_READ();
			INI_DEL();
			// если ОК в 2 диалоге
			if( DIALOG_2() )
			{
				ALIGN();
			};
		}
		else
		// если НЕ в порядке выделение
		{
			INI_DEL();
		};
	};// if
	the_exit("");
	return;
};// end AFTER_RUN
//
// подпрограмма удаления файла данных
function INI_DEL()
{
	// получаем ссылку на файл скрипта
	SCRIPT_FILE = File(app.activeScript);
	// получаем адрес папки со скриптом
	SCRIPT_FOLDER = SCRIPT_FILE.path;
	// получаем ссылку на файл данных
	INI_FILE = File( SCRIPT_FOLDER + "/"+ the_script_name +".ini" );
	// существует ли он
	INI_EXISTS = INI_FILE.exists;
	try
	{
		INI_FILE.remove();
	} catch ( error ) {};
	return;
};// end INI_DEL
// 
// подпрограмма чтения начальных значений из файла
function INI_READ()
{
	// получаем ссылку на файл скрипта
	SCRIPT_FILE = File(app.activeScript);
	// получаем адрес папки со скриптом
	SCRIPT_FOLDER = SCRIPT_FILE.path;
	// получаем ссылку на файл данных
	INI_FILE = File( SCRIPT_FOLDER + "/"+ the_script_name +".ini" );
	// существует ли он
	INI_EXISTS = INI_FILE.exists;
	// если не существует, считаем что это первый вызов скрипта
	if( !INI_EXISTS )
	{
		if( DIALOG_1() )
		{
			INI_WRITE();
			the_exit("");
		};// if
	}
	// если существует, получаем начальные значения из этого файла
	else 
	{
		try
		{
			FILE_IO( false );
		} 
		catch ( error ) { };// try-catch
	};// if-else
	return;
};// end INI_READ
//
// подпрограмма записи начальных значений в файл
function INI_WRITE()
{
	// существует ли файл (на всякий случай еще раз)
	INI_EXISTS = INI_FILE.exists;
	// если не существует, пытаемся создать
	if( !INI_EXISTS ) 
	{
		try
		{
			// получаем ссылку на файл скрипта
			SCRIPT_FILE = File(app.activeScript);
			// получаем адрес папки со скриптом
			SCRIPT_FOLDER = SCRIPT_FILE.path;
			// получаем ссылку на файл данных
			INI_FILE = File( SCRIPT_FOLDER + "/"+ the_script_name +".ini" );
		} catch ( error ) {}
	};// if
	try
	{
		FILE_IO( true );
	} catch ( error ) {};
	return;
};// end INI_WRITE
//
// подпрограмма проверки данных при чтении/записи
function BAD_DATA( x )
{ 
	if( isNaN(parseFloat(x)) || x == undefined ) return true;
	return false;
};// end BAD_DATA
//
// подпрограмма чтения/записи в файл данных
function FILE_IO( n )
{
	INI_ERR = false;
	var r = new Array();
	var w = new Array();
	// число параметров ввода/вывода
	var N_PAR = 10;
	try 
	{
		// если стина, то открываем на запись
		if( n ) INI_FILE.open("w")
		// если ложь то открываем на чтение
		else INI_FILE.open("r");
		// назначение первого выделения
		if( n ) INI_FILE.writeln( FIRST_MOVED )
		else FIRST_MOVED = parseInt( INI_FILE.readln() );
		// количество объектов в 1 выделении
		if( n ) INI_FILE.writeln( N_sel_1 )
		else N_sel_1 = parseInt( INI_FILE.readln() );
		
		for( var i=0; i < N_sel_1; i++ )
		{
			if( n ) 
			{ 
				INI_FILE.writeln( SEL_1_ID[i] );
			}
			else 
			{
				SEL_1_ID[i] = parseInt( INI_FILE.readln() );
			};// if-else
		};// for
		// закрываем файл
		INI_FILE.close();
	}
	catch ( error )
	{
		INI_ERR = true;
	};// try-catch
	try{ INI_FILE.close() } catch( error ) {};
	return;
};// end FILE_IO
//
// подпрограмма восстановления старых настроек док-та
function RESTORE_OLD_DOC_SETTINGS() {
	try
	{
		AD.viewPreferences.rulerOrigin = AD_old_ruler_origin;
	} catch ( error ) {};
	return; 
};// end RESTORE_OLD_DOC_SETTINGS
//
// подпрограмма определения макс. значения в массиве
function MAX_IN_ARRAY ( the_array) 
{
	var MAX =  the_array[0];
	for ( var i = 0; i < the_array.length; i++ ) 
	{
		if(  the_array[i] > MAX ) MAX =  the_array[i];
	}
	return MAX;
}// end  MAX_IN_ARRAY
//
// подпрограмма определения мин. значения в массиве
function MIN_IN_ARRAY ( the_array) 
{
	var MIN =  the_array[0];
	for ( var i = 0; i < the_array.length; i++ ) 
	{
		if(  the_array[i] < MIN ) MIN =  the_array[i];
	};// for
	return MIN;
}// end MIN_IN_ARRAY
//
// подпрограмма получения границ по выделению
function OBJ_BOUNDS ( the_obj ) 
{
	// left
	var g_L =  the_obj.geometricBounds[1];
	var v_L =  the_obj.visibleBounds[1];
	// top
	var g_T =  the_obj.geometricBounds[0];
	var v_T =  the_obj.visibleBounds[0];
	// right
	var g_R =  the_obj.geometricBounds[3];
	var v_R =  the_obj.visibleBounds[3];
	// bottom
	var g_B =  the_obj.geometricBounds[2];
	var v_B =  the_obj.visibleBounds[2];
	return [g_L, g_T, g_R, g_B,   v_L, v_T, v_R, v_B];
}// end SEL_OBJ_BOUNDS
//
// продпрограмма определения является ли объект направляющей
function IS_GUIDE ( the_obj ) 
{
	try 
	{
		if (the_obj.guides)  
		{
			return true;
		}
	} catch (error) {}
	return false;
}// end  IS_GUIDE
//
// подпрограмма определения единиц для линеек документа
function GET_RULER_UNITS_TEXT(the_units) 
{
	switch ( the_units ) 
	{
		case (2054188905): return "pt";// points
		case (2054187363): return "pc";// picas
		case (2053729891): return "in";// inches
		case (2053729892): return "ind";// inches decimal
		case (2053991795): return "mm";
		case (2053336435): return "cm";
		case (2053335395): return "ci";// ciceros
		case (1131639917): return "pt";// custom
		case (2051106676): return "ag";// agates
		default: return "??";
	}// switch
	return "??";
}// GET_RULER_UNITS_TEXT;
//
// функция чтения текстового ввода в активных единицах и перевода в пункты
function TEXT_TO_POINTS ( txt, u ) 
{
	var d = txt.toLowerCase();
	var k = 1.;
	if( u == 'pt' ) k = 1.; 
	if( u == 'in' ) k = 72.; 
	if( u == 'mm' ) k = (72./25.4); 
	if( u == 'cm' ) k = ((72./25.4)*10.);
	d = parseFloat( TEXT_TO_DIGIT(txt) ) * k;
	// если не цифра, обнуляем
	 if( isNaN(d) ) 
	 {
		 d = 0.;
		 exit_if_bad_input = true;
		 return;
	}
	// возвращаем значение в пунктах для расчета
	return d;
};// end TEXT_TO_POINTS
//
// подпрограмма получения единиц из меню
function GET_UNITS_DROP( N ) 
{
	if( N == 0 ) return "mm";
	if( N == 1 ) return "cm";
	if( N == 2 ) return "pt";
	if( N == 3 ) return "in";
	return "pt";
};// GET_UNITS_DROP
//
// подпрограмма окончания скрипта
function the_exit(txt)
{
	try
	{
		RESTORE_OLD_DOC_SETTINGS();
	} catch (error) {};
	if( txt !="") alert(txt);
	exit();
};// end the_exit
//
// подпрограмма получения ID объектов
function GET_ID( arr_in )
{
	try
	{
		var arr_out = new Array();
		var N = arr_in.length;
		for( var i = 0; i < N; i++)
		{
			try
			{
				arr_out[i] = arr_in[i].id;
			} catch ( error ) {};
		};// for i
		return arr_out;
	} 
	catch ( error ) 
	{
		return false;
	};
};// end GET_ID
//
// подпрограмма получения объектов из ID
function GET_OBJ_FROM_ID( arr_in )
{
	var arr_out = new Array();
	for( var i=0; i<arr_in.length; i++)
	{
		arr_out[i] = AD.pageItems.itemByID( arr_in[i] );
	};// for
	return arr_out;
};// end GET_OBJ_FROM_ID
//
// подпрограмма позиционирования текста
function TEXT_XY(x, y, w, where, txt)
{
	var t = where.add('statictext');
	var t_h = 20;
	t.bounds = [x, y, x+w, y+t_h];
	t.text = txt;
	return t;
};// end TEXT_XY
//
// подпрограмма позиционирования текста для плюса и минуса
function TEXT_XY_PM(x, y, w, where, txt)
{
	var t = where.add('statictext');
	var t_h = 10;
	t.bounds = [x, y, x+w, y+t_h];
	t.text = txt;
	return t;
};// end TEXT_XY
//
// подпрограма позиционирования дропдауна
function DROP_XY(x, y, w, where, arr, ini)
{
	var d = where.add('dropdownlist');
	var d_h = 20;
	d.bounds = [x, y, x+w, y+d_h];
	for(var i=0; i<arr.length; i++) d.add('item', arr[i]);
	d.selection = ini;
	return d;
};// end DROP_XY
//
// подпрограма позиционирования дропдауна
function MAKE_STATICTEXT(where, txt)
{
	var t = where.add('statictext');
	t.text = txt;
	return t;	
}
//
function MAKE_DROPDOWN(where, txt, arr, ini)
{
	var g = where.add('group');
	g.orientation = 'row';
	g.alignChildren = 'left';
	MAKE_STATICTEXT(g, txt)
	var d = g.add('dropdownlist');
	for(var i=0; i<arr.length; i++) d.add('item', arr[i]);
	d.selection = ini;
	return d;
};
//
function CHECKBOX_XY(x, y, w, where, txt, ini)
{
	var C = where.add('checkbox');
	var c_h = 25;
	C.bounds = [x, y, x+w, y+c_h];
	C.text = txt;
	C.value = ini;
	return C;	
}
//
function MAKE_CHECKBOX(where, txt, ini)
{
	var C = where.add('checkbox');
	var c_h = 25;
	C.text = txt;
	C.value = ini;
	return C;	
}
//
// подпрограмма создания первого диалога
function DIALOG_1()
{
	dlg = new Window('dialog');
	var SEL_AFTER;
	dlg.text = the_title + " v." +the_version; // заголовок диалога
	var mp = dlg.add('panel');
	mp.alignChildren = 'left';
	var DEST = MAKE_DROPDOWN(mp, "Functional destination for the selection: ", ["moved objects", "reference (key) objects"], 0);
	DEST.onChange = DEST_ON_CHANGE;
	DEST.maximumSize.width = 110;
	var g1 = mp.add('group');
	g1.alignChildren = 'left';
	g1.orientation = 'row';
	MAKE_STATICTEXT(g1, ("Objects selected: "+N_sel+" ") );
	DESEL = MAKE_CHECKBOX(g1, "Deselect the selection after [OK]", false);
	DESEL.onClick = DEST_ON_CHANGE;
	SEL_AFTER = MAKE_STATICTEXT(mp, "After [OK] select objects to be reference ones using [Shift]" );
	MAKE_STATICTEXT(mp, "Then re-run the script "+the_script_name+".jsx" );
	// создание панели кнопок (кнопка ОК, кнопка Cancel)
	var OK_G =dlg.add('group');
	OK_G.alignChildren = 'center';
	OK_G.orientation = 'row';
	var OK_BUTTON = OK_G.add('button', undefined, 'OK');// кнопка ОК
	var CANCEL_BUTTON =OK_G.add('button',undefined, 'Cancel');// кнопка Cancel
	// подпрограмма реакции на выбор опций
	function DEST_ON_CHANGE()
	{
		var S =  DEST.selection.index;
		var C = DESEL.value;
		var SH = "";
		if( !C ) SH = " using [Shift]";
		if( S==0 ) SEL_AFTER.text = "After [OK] select objects to be reference ones"+SH;
		if( S==1 ) SEL_AFTER.text = "After [OK] select objects to be moved ones"+SH;
	};// end DEST_ON_CHANGE
	// выводим окно диалога
	var DIALOG_BUTTON = dlg.show();
	// если нажали ОК
	if( DIALOG_BUTTON == 1 ) 
	{
		// снимать 1 выделение 
		DESEL = DESEL.value;
		//if( DESEL ) DESEL = 1 else DESEL = 0;
		// первое выделение перемещаемое или референс
		if( DEST.selection.index == 0 ) FIRST_MOVED = 1;
		if( DEST.selection.index == 1 ) FIRST_MOVED = 0;
		// количество объектов в 1 выделении
		N_sel_1 = N_sel;
		// массив ID 1 выделения
		SEL_1_ID = GET_ID( the_sel );
		return true;
	}
	// если нажали Cancel
	if( DIALOG_BUTTON == 2 ) return false;
};// end  DIALOG_1
//
// подпрограмма создания второго диалога
function DIALOG_2()
{
	// если первое выделение перемещаемое
	if( FIRST_MOVED == 1 ) 
	{
		MOV_OBJ = GET_OBJ_FROM_ID( SEL_1_ID );
		REF_OBJ = the_sel;
	};// if
	// если первое выделение референс
	if( FIRST_MOVED == 0 ) 
	{
		MOV_OBJ = the_sel;
		REF_OBJ = GET_OBJ_FROM_ID( SEL_1_ID );
	}
	// определяем опорные объекты, токорые могли быть выделени с шифтом
	if( FIRST_MOVED == 1 )
	{
		var REF_WITH_SHIFT = new Array();
		for( var i=0; i < REF_OBJ.length; i++)
		{
			if( !OBJ_IN_ARR( REF_OBJ[i], MOV_OBJ ) ) REF_WITH_SHIFT.push( REF_OBJ[i] );
		};// for
		REF_OBJ = REF_WITH_SHIFT;
	};// if FIRST_MOVED == 1
	if( FIRST_MOVED == 0 )
	{
		var MOV_WITH_SHIFT = new Array();
		for( var i=0; i <MOV_OBJ.length; i++)
		{
			if( !OBJ_IN_ARR( MOV_OBJ[i], REF_OBJ ) ) MOV_WITH_SHIFT.push( MOV_OBJ[i] );
		};// for
		MOV_OBJ = MOV_WITH_SHIFT;
	};// if FIRST_MOVED == 1
	N_MOV_OBJ = MOV_OBJ.length;
	N_REF_OBJ = REF_OBJ.length;
	// проверяем не совпадают ли перемещаемые и референсные объекты
	var MIX_REF_MOV = false;
	for( var i=0; i <MOV_OBJ.length; i++) if( OBJ_IN_ARR( MOV_OBJ[i], REF_OBJ ) ) MIX_REF_MOV = true;
	for( var i=0; i <REF_OBJ.length; i++) if( OBJ_IN_ARR( REF_OBJ[i], MOV_OBJ ) ) MIX_REF_MOV = true;
	if( MIX_REF_MOV || N_MOV_OBJ == 0 || N_REF_OBJ == 0 )
	{
		the_exit("There is some objects destination mismatch!\n"+
					 "Can not process that!");
	};// if
	H_UNITS_TEXT = GET_RULER_UNITS_TEXT(AD.viewPreferences.horizontalMeasurementUnits);
	V_UNITS_TEXT = GET_RULER_UNITS_TEXT(AD.viewPreferences.verticalMeasurementUnits);
	dlg = new Window('dialog');
	dlg.text = the_title + " v." +the_version; // заголовок диалога
	mp = dlg.add('panel');
	mp.orientation = 'row'
	mp.alignChildren = 'left';
	mp.alignChildren = 'top';
	var mp_left = 5;
	var mp_top = 5;
	var mp_right = 450;
	var mp_bottom = 175;
	mp.bounds = [mp_left, mp_top, mp_right, mp_bottom];
	// подпрограмма создания окна ввода с единицами
	function ED_TEXT(where, x_e, y_e, what, ini_txt, un_txt, hor)
	{
		var dx = 3;
		var h = 22;
		var what_txt = where.add('statictext');
		var what_txt_w = 20;
		var d_txt = 5;
		var what_txt_left = x_e, what_txt_top = y_e+d_txt, what_txt_right = what_txt_left+what_txt_w, what_txt_bottom = y_e+h; 
		what_txt.bounds = [what_txt_left, what_txt_top, what_txt_right, what_txt_bottom];
		what_txt.text = what;
		//
		var et = where.add('edittext');
		var w_et = 35;
		var et_left = what_txt_right+dx, et_top = y_e, et_right = et_left+w_et, et_bottom = y_e+h;
		et.bounds = [et_left, et_top, et_right, et_bottom];
		et.text = ini_txt;
		et.onChanging = et_on_Changing;
		function et_on_Changing()
		{
			digit_on_Changing(et, ini_txt, "0");
			return;
		};// end  et_on_Changing
		var un = where.add('statictext');
		var w_un = 27;
		var un_left = et_right+dx, un_top = y_e+d_txt, un_right = un_left+w_un, un_bottom = y_e+h; 
		un.bounds = [un_left, un_top, un_right, un_bottom];
		un.text = un_txt;
		//
		if(hor)
		{
			minus = TEXT_XY(x_e+25, y_e+h, 9, mp, "-");
			plus = TEXT_XY(x_e+w_et+13, y_e+h, 9, mp, "+");
		}
		else
		{
			minus = TEXT_XY_PM( x_e+what_txt_w+5, y_e+h-37, 9, mp, "-");
			plus = TEXT_XY(x_e+what_txt_w+5, y_e+h, 9, mp, "+");
		}
		//
		return [what_txt, et, un, minus, plus];
	};// end ED_TEXT
	//
	// подпрограмма создания группы выбора направлений по горизонтали
	function MAKE_HOR( x, y )
	{
		var ddx = 17;
		// создаем чекбокс
		var cb_w = 90;
		var cb = CHECKBOX_XY(x-ddx, y, cb_w, mp, "Horizontal", 0);
		cb.onClick = CB_ON_CLICK;
		// создаем группу для радиокнопок
		var RG = mp.add('group');
		var RG_left = x+cb_w-ddx, RG_w = 175, RG_right = RG_left + RG_w;
		var RG_h = 25;
		var R_MINUS = 0;// поправка правого края
		RG.bounds = [RG_left, y-3, RG_right - R_MINUS, y+RG_h];
		//
		arr_dir = new Array ("Left", "Center", "Right");
		var RB_ARR = new Array();
		var RB_left = 3, RB_top = 3; 
		var RB_w = 45;// left 
		var RB_h = RG_h;
		var RB_right = RB_left + RB_w;
		// left
		RB_ARR[0] = RG.add('radiobutton');
		RB_ARR[0].text = arr_dir[0];
		RB_ARR[0].bounds = [RB_left, RB_top, RB_right, RB_top+RB_h];
		// center
		RB_left = RB_right + 3;
		var RB_w = 63;// center
		RB_right = RB_left + RB_w;
		RB_ARR[1] = RG.add('radiobutton');
		RB_ARR[1].text = arr_dir[1];
		RB_ARR[1].bounds = [RB_left, RB_top, RB_right, RB_top+RB_h];
		// right
		RB_left = RB_right + 3;
		var RB_w = 60;// right
		RB_right = RB_left + RB_w;
		RB_ARR[2] = RG.add('radiobutton');
		RB_ARR[2].text = arr_dir[2];
		RB_ARR[2].bounds = [RB_left, RB_top, RB_right, RB_top+RB_h];
		//
		var ET_ARR = new Array();
		ET_ARR = ED_TEXT(mp, RB_right+175, RB_top, "dX:", "0", H_UNITS_TEXT, true);
		//
		for( var i = 0; i < arr_dir.length; i++) 
		{
			RB_ARR[i].value =  RB_ARR[i].enabled = false;
		};// for i
		for( var i=0; i<ET_ARR.length; i++)
		{
			ET_ARR[i].enabled = false;
		}
		//
		function CB_ON_CLICK()
		{
			var CB_V = cb.value;
			if( !CB_V )
			{
				for( var i = 0; i < arr_dir.length; i++) 
				{
					RB_ARR[i].value = RB_ARR[i].enabled = false;
					
				}
				for( var i=0; i<ET_ARR.length; i++)
				{
					ET_ARR[i].enabled = false;
				}
				ET_ARR[1].text = "0";
			}
			else
			{
				for( var i = 0; i < arr_dir.length; i++) 
				{
					RB_ARR[i].enabled = true;
				}
				RB_ARR[1].value = true;
				for( var i=0; i<ET_ARR.length; i++)
				{
					ET_ARR[i].enabled = true;
				}
			}
			return;		
		};// end CB_ON_CLICK
		//
		return [cb, RB_ARR, ET_ARR[1]];
	};// end MAKE_HOR
	//
	// подпрограмма создания группы выбора направлений по вертикали
	function MAKE_VER(x, y )
	{
		// создаем чекбокс
		var cb_w = 70;
		var cb = CHECKBOX_XY(x, y, x+cb_w-5, mp, "Vertical", 0);
		cb.onClick = CB_ON_CLICK;
		// создаем группу для радиокнопок
		var RG = mp.add('group');
		var RG_left = x
		var RG_w = cb_w+20;
		var RG_right = RG_left + RG_w;
		var RG_h = 80;
		var RG_top = y+30;
		var RG_bottom = RG_top+RG_h;
		var R_MINUS = 20;// поправка для левого края
		RG.bounds = [RG_left, RG_top, RG_right- R_MINUS, RG_bottom];
		//
		arr_dir = new Array ("Top", "Center", "Bottom");
		var RB_ARR = new Array();
		var RB_dy = 10;
		var RB_left = 0, RB_top = 0;
		var RB_w = RG_w, RB_h = 18;
		for( var i = 0; i < arr_dir.length; i++) 
		{
			RB_ARR[i] = RG.add('radiobutton');
			RB_ARR[i].text = arr_dir[i];
			RB_ARR[i].value =  RB_ARR[i].enabled = false;
			RB_bottom = RB_top+RB_h;
			RB_ARR[i].bounds = [RB_left, RB_top, RB_left + RB_w- R_MINUS, RB_bottom];
			RB_top = RB_bottom + RB_dy;
		};// for i
		//
		var ET_ARR = new Array();
		var ed_txt_dy = 40;
		ET_ARR = ED_TEXT(mp, RG_left+3, RB_top+ed_txt_dy, "dY:", "0", V_UNITS_TEXT, false);
		//
		for( var i = 0; i < arr_dir.length; i++) 
		{
			RB_ARR[i].value =  RB_ARR[i].enabled = false;
		};// for i
		for( var i=0; i<ET_ARR.length; i++)
		{
			ET_ARR[i].enabled = false;
		}
		//
		function CB_ON_CLICK()
		{
			var CB_V = cb.value;
			if( !CB_V )
			{
				for( var i = 0; i < arr_dir.length; i++) 
				{
					RB_ARR[i].value = RB_ARR[i].enabled = false;
				}
				for( var i=0; i<ET_ARR.length; i++)
				{
					ET_ARR[i].enabled = false;
				}
				ET_ARR[1].text = "0";
			}
			else
			{
				for( var i = 0; i < arr_dir.length; i++) 
				{
					RB_ARR[i].enabled = true;
				}
				RB_ARR[1].value = true;
				for( var i=0; i<ET_ARR.length; i++)
				{
					ET_ARR[i].enabled = true;
				}
			}
			return;		
		};// end CB_ON_CLICK
		//
		return [cb, RB_ARR, ET_ARR[1]];
	};// end MAKE_VER
	//
	function DIAL_V_LINE(x, y, h ) 
	{ 
		var p = mp.add('panel'); p.bounds = [x, y, undefined, x+h];
	}
	function DIAL_H_LINE(x, y, l ) 
	{ 
		var p = mp.add('panel'); p.bounds = [x, y, x+l, undefined];
	}
	var mk_ver_x = 6, mk_ver_y = 3;
	var mk_hor_x = 100, mk_hor_y = 3;
	var VER_GR = MAKE_VER(mk_ver_x, mk_ver_y );
	var HOR_GR = MAKE_HOR(mk_hor_x, mk_hor_y );
	var L1_x = 105, L1_y = 45;
	DIAL_V_LINE(L1_x, L1_y, mp_bottom-L1_y );
	DIAL_H_LINE(L1_x, L1_y, mp_right-L1_x );
	//
	var obj_name_x = mk_hor_x+12;
	var obj_name_y = 55;
	var txt_len = 115;
	var obj_dy = 29;
	TEXT_XY(obj_name_x, obj_name_y, txt_len, mp, "Reference objects:"); 
	var MOV_OBJ_TEXT  = TEXT_XY(obj_name_x, obj_name_y+obj_dy, txt_len, mp, "Movable objects:");
	var num_len = 40;
	TEXT_XY(5+obj_name_x+txt_len, obj_name_y, num_len, mp, N_REF_OBJ+""); 
	TEXT_XY(5+obj_name_x+txt_len, obj_name_y+obj_dy, num_len, mp, N_MOV_OBJ+""); 
	var b_len = 50;
	TEXT_XY(10+obj_name_x+txt_len+num_len, obj_name_y, b_len, mp, "Bounds:"); 
	TEXT_XY(10+obj_name_x+txt_len+num_len, obj_name_y+obj_dy, b_len, mp, "Bounds:"); 
	var drop_len = 100;
	var REF_B = DROP_XY(15+obj_name_x+txt_len+num_len+b_len , obj_name_y, drop_len, mp, ["Geometric","Visible"], 0)
	var MOV_B = DROP_XY(15+obj_name_x+txt_len+num_len+b_len , obj_name_y+obj_dy, drop_len, mp, ["Geometric","Visible"], 0)
	//
	var aft_len = 160;
	var aft_y = obj_name_y+obj_dy+obj_dy;
	TEXT_XY(obj_name_x, aft_y, aft_len, mp, "Selection after operation:"); 
	var S_AFT = DROP_XY(5+obj_name_x+aft_len , aft_y, 155, mp, ["All involved objects", "Moved objects", "Reference objects", "Deselect all"], 0);
	//
	var like_group_y = aft_y+obj_dy-5;
	var like_group_w = 200;
	LIKE_GROUP = CHECKBOX_XY(obj_name_x, like_group_y, like_group_w, mp, "Move objects like a group", 1);
	if( N_MOV_OBJ == 1 ) LIKE_GROUP.enabled = LIKE_GROUP.value = false;
	//
	var move_copy_y = like_group_y;
	var move_copy_x = obj_name_x+like_group_w+20;
	var MC_TXT = "copies"; 
	if( N_MOV_OBJ == 1 ) MC_TXT = "copy";
	MOVE_COPY = CHECKBOX_XY(move_copy_x, move_copy_y, like_group_w, mp, "Move "+MC_TXT, 0);
	MOVE_COPY.onClick = MOVE_COPY_ON_CLICK;
	function MOVE_COPY_ON_CLICK()
	{
		var S_AFT_SEL = S_AFT.selection.index;
		S_AFT.selection = 0;
		if( !MOVE_COPY.value )
		{
			if( N_MOV_OBJ != 1 ) LIKE_GROUP.text = "Move objects like a group";
			MOV_OBJ_TEXT.text = "Movable objects:";
			S_AFT.items[1].text = "Moved objects";
			try{ S_AFT.remove( S_AFT.items[4]) } catch( error ) {};
			if( S_AFT_SEL == 4 ) S_AFT_SEL = 1;
		}
		else
		{
			if( N_MOV_OBJ != 1 ) LIKE_GROUP.text = "Move copies like a group";
			MOV_OBJ_TEXT.text = "Original objects:";
			S_AFT.items[1].text = "Original objects";
			var COPY_TEXT = "Copies";
			if( N_MOV_OBJ == 1 )  COPY_TEXT = "Copy";
			S_AFT.add('item', COPY_TEXT);
		}
		S_AFT.selection = S_AFT_SEL;
	};// end MOVE_COPY_ON_CLICK
	// создание панели кнопок (кнопка ОК, кнопка Cancel)
	var OK_G =dlg.add('group');
	OK_G.alignChildren = 'center';
	OK_G.orientation = 'row';
	var OK_BUTTON = OK_G.add('button', undefined, 'OK');// кнопка ОК
	var CANCEL_BUTTON =OK_G.add('button',undefined, 'Cancel');// кнопка Cancel
	// выводим окно диалога
	var DIALOG_BUTTON = dlg.show();
	// если нажали ОК
	if( DIALOG_BUTTON == 1 ) 
	{
		// выравнивание по горизонтали
		AH = HOR_GR[0].value;
		// лево
		AL = HOR_GR[1][0].value;
		// центр горизонтальный 
		ACH = HOR_GR[1][1].value;
		// право
		AR = HOR_GR[1][2].value;
		// выравнивание по вертикали
		AV = VER_GR[0].value;
		// верх
		AT = VER_GR[1][0].value;
		// центр вертикальный 
		ACV = VER_GR[1][1].value;
		// низ
		AB = VER_GR[1][2].value;		
		REF_OBJ_BOUNDS = REF_B.selection.text;
		MOV_OBJ_BOUNDS = MOV_B.selection.text;
		LIKE_GROUP = LIKE_GROUP.value;
		SEL_AFTER = S_AFT.selection.text;
		SHIFT_X = TEXT_TO_DIGIT ( HOR_GR[2].text );
		SHIFT_Y = TEXT_TO_DIGIT ( VER_GR[2].text );
		MOVE_COPY = MOVE_COPY.value;
		return true;
	};
	// если нажали Cancel
	if( DIALOG_BUTTON == 2 ) return false;
};// end DIALOG_2
//
function DESELECT_ALL()
{
	app.selection = null;
	return;
};// end 
//
function SEL_OBJ(arr)
{
	try{
		for( var i=0; i < arr.length; i++)
		{
			try
			{
				arr[i].select( SelectionOptions.addTo );
			} catch ( error ) {};
		};// for
	} catch( error ) {};
	return;	
};// end SEL_OBJ
//
// подпрограмма определения Lock position для содержимого
// фрейма или элемента группы
function IN_LOCKED(OBJ)
{
	var the_object;
	var the_parent;
	var the_name;
	the_object = OBJ;
	var i = 0;
	do 
	{
		the_parent = the_object.parent;
		the_name = the_parent.constructor.name;
		if(!(the_name == "Rectangle" || the_name == "Oval" || the_name == "Polygon" || the_name == "Group")) break;
		the_object = the_parent;
		i = i + 1;
		if( i > MAX_LOOP ) break;
	} while (true);
	if( the_object.locked) return true;
	return false
};// end IN_LOCKED(OBJ)
//
// подпрограмма разблокирования фрейма или группы
function UNLOCK_PARENT(OBJ)
{
	var the_object;
	var the_parent;
	var the_name;
	the_object = OBJ;
	var i = 0;
	do 
	{
		the_parent = the_object.parent;
		the_name = the_parent.constructor.name;
		if(!(the_name == "Rectangle" || the_name == "Oval" || the_name == "Polygon" || the_name == "Group")) break;
		the_object = the_parent;
		i = i + 1;
		if( i > MAX_LOOP ) break;
	} while (true);
	the_object.locked = false;
	return
};// end UNLOCK_PARENT(OBJ)
//
// обработка поля ввода в процессе
function digit_on_Changing(et, def, emp) {
	var s =et.text;
	if( s == "") 
	{
		et.text = emp;
		return;
	};
	if( !INP_OK ) 
	{
		et.text = def;
		INP_OK = true;
		return;
	}
	var d;
	var BNP = false;
	var N_C = 0;
	var N_P = 0;
	var N_M = 0;
	for( var i=0; i < s.length; i++ ) 
	{
		var si = s[i];
		if( si == "." || si == "," ) N_C = N_C +1;
		if( si == "-" ) N_M = N_M +1;
		if( si == "+" ) N_P = N_P +1;
		if
		( 
			((si != "-" && si != "+" && si != "." && si != "," && NO_DIGIT_SYMBOL(si)) || N_C>1 ) ||
			((N_P + N_M)>1) ||
			( si == "-"  && i !=0 ) ||
			( si == "+"  && i !=0 )
		) 
		{
			BNP = true;
			et.active = true;
			INP_OK = false;
			alert("Bad number input!");
			et.text = def;
			return;
		};// if
	};// for
	return;
};// end digit_on_Changing
//
//
function NO_DIGIT_SYMBOL( s ) {
	try{
	if( s!= "0" && s!= "1" && s!= "2" && s!= "3" && s!= "4" && 
		s!= "5" && s!= "6" && s!= "7" && s!= "8" && s!= "9") return true;
	} catch( error ) {};
	return false;
};//
// подпрограмма определения единиц для линеек документа
function GET_RULER_UNITS_TEXT(the_units) {
	switch ( the_units ) {
		case (2054188905): return "pt";// points
		case (2054187363): return "pc";// picas
		case (2053729891): return "in";// inches
		case (2053729892): return "ind";// inches decimal
		case (2053991795): return "mm";
		case (2053336435): return "cm";
		case (2053335395): return "ci";// ciceros
		case (1131639917): return "pt";// custom
		case (2051106676): return "ag";// agates
		default: return "??";
	}// switch
return "??";
}// GET_RULER_UNITS_TEXT;
//
// функция чтения текстового ввода и перевода в число
function TEXT_TO_DIGIT ( txt ) {
	var s = "";
	// если пусто то ноль
	if( txt == "" ) s = "0";
	if( txt == "+" ) s = "0";
	if( txt == "-" ) s = "0";
	var only_space = true;
	for( var i=0; i < txt.length; i++ ) {
		if( txt[i] != " " ) only_space = false;
		if( txt[i] == ",") s = s + "." else s = s + txt[i];
	};// for
	// если только пробелы то ноль
	if( only_space ) s = "0";
	if( s == ".")  s = "0";
	if( s == "-")  s = "0";
	var s1 = "";
	for( var i=0; i < s.length; i++ ) {
		if( s[i] == " " ) continue;
		s1 = s1 + s[i];
	};// for
	var d = parseFloat( s1 );
	// возвращаем значение в пунктах для расчета
return d;
}// end TEXT_TO_DIGIT